<?php 
   /* 
     30.01.2014

     Version 1.2
	 
     Script zum Entfernen von Metadaten aus einer PDF-Datei. 
   */
header("Content-Type: text/html; charset=UTF-8");
?>
<!DOCTYPE html>
<html>
    <head>
        <title> pdfmetadaten/entfernen.php </title>
		<style type="text/css">
			body {
				font-family: Tahoma, sans-serif;
				font-size: 10pt;
				background: #acacac;
			}
			div.inhalt {
				margin-left: auto;
				margin-right: auto;
				margin-top: 30px;
				padding: 30px;
				background: white;
				box-shadow: 1px 1px 5px #666666;
				border-radius: 3px;
				width: 800px;			
			}
			div.output {
				margin-left: auto;
				margin-right: auto;
				margin-top: 30px;
				padding: 15px;
				background: #efefef;
				width: 740px;
				border-radius: 3px;
				overflow: auto;
			}
			input#filename {
				width: 750px;
			}
			.hinweis {
				color: red;
				margin: 30px 0;
			}
		</style>
    </head>
    <body>
<?php   
   $finfo = new finfo(FILEINFO_MIME_TYPE);
   $prefix="_";
   
   // Formular anzeigen
   
   // wenn eine DocumentId übergeben wurde, dann das Formular vorbelegen
   if (isset($_GET['documentId']) && is_numeric($_GET['documentId']) && preg_match('/^\d+$/',$_GET['documentId'])) {
	   $documentId = $_GET['documentId'];
   } elseif (isset($_POST['documentId']) && is_numeric($_POST['documentId']) && preg_match('/^\d+$/',$_POST['documentId'])) {
	   $documentId = $_POST['documentId'];
   } else {
	   $documentId = "";
   }
   // wenn ein filename übergeben wurde, dann das Formular vorbelegen
   if (isset($_GET['filename']) && preg_match('/\.pdf$/', $_GET['filename'])) {
	   $filename = $_GET['filename'];
   } elseif (isset($_POST['filename']) && preg_match('/\.pdf$/', $_POST['filename'])) {
	   $filename = $_POST['filename'];
   } else {
	   $filename = "";
   }    
?>
        <div class="inhalt">
            <div><h1>Kopie einer PDF-Datei ohne Metadaten erstellen</h1></div>
            <div class="hinweis">Achtung: Beim Ausführen des Scripts werden alle vorhandenen Dateien im Incoming-Verzeichnis ohne weitere Nachfrage gelöscht!</div>
		
	    <form method="post" action="entfernen.php">
	        <div>
		    <label for="documentId">
		        <p> Bitte Dokument-Nummer eingeben: </p>
		    </label>
		    <input id="documentId" type="text" name="documentId" value="<?php echo $documentId; ?>" />
			<label for="filename">
		        <p> Bitte Dateinamen eingeben: </p>
		    </label>
		    <input id="filename" type="text" name="filename" value="<?php echo $filename; ?>" />
		    <input id="button" type="hidden" name="action" value="process" />
		</div>
		<div>
			<br />
		    <input type="submit" value="OK" />
	    </div>
	    </form>
<?php
   if ($_POST['action'] == 'process' && isset($_POST['filename']) && preg_match('/\.pdf$/', $_POST['filename']) && isset($_POST['documentId']) && is_numeric($_POST['documentId']) && preg_match('/^\d+$/', $_POST['documentId'])) {
        // Metadaten entfernen
        $documentId = $_POST['documentId'];
		$filename = $_POST['filename'];
        $documentDir=__DIR__ .'/../../../workspace/files/'.$documentId;
        $incomingDir=__DIR__ .'/../../../workspace/incoming/';
		$longFilename_unescaped = "$documentDir/$filename";
		$longFilename = escapeshellarg("$documentDir/$filename");
        if (is_dir($documentDir)) {
            $dirContent = scandir($documentDir);
			echo "<div class=\"output\">";
            echo "<pre>";
            $dirContent=scandir($incomingDir);
            if (count($dirContent)){
                echo "Lösche Dateien im incoming-Verzeichnis:\n";
                        
                foreach($dirContent as $delFilename){
                    if (is_file("$incomingDir$delFilename")){
                        unlink("$incomingDir$delFilename");                    
                        echo "Datei $incomingDir$delFilename gelöscht.\n";
                    }
                }
				echo "\n";
            }
            
           $dirContent = scandir($documentDir);
		   if (is_file($longFilename_unescaped)){ 		   
			   if ($finfo->file($longFilename_unescaped)=="application/pdf"){
				   $output=array();
				   $exifdata=array();
				   exec("exiftool $longFilename", $output);
				   foreach ($output as $line){
					   $temp = preg_split('/\s*:\s*/', $line);
					   $key = trim($temp[0]);
					   $value=trim($temp[1]);
					   $exifdata[$key] = $value;
				   }
				   if (isset($exifdata['Conformance'])){
					   echo "</pre><p style=\"color: orange;\">Hiweis: Die Datei $filename ist PDF-A/".$exifdata['Version ID'].$exifdata['Conformance']." konform. -> übersprungen</p><pre>";
				   } else {
						if (isset($exifdata['User Access'])) {
							echo "</pre><p style=\"color: red;\">Warnung: Die Datei $filename ist Kennwortgeschützt!</p><pre>";
						}
						echo "Kopiere $longFilename \n nach -> " . escapeshellarg("$incomingDir$prefix$filename") . "\n\n";
						passthru ("cp -p $longFilename " . escapeshellarg("$incomingDir$prefix$filename") );
						echo "Entferne Metadaten aus " . escapeshellarg("$incomingDir$prefix$filename"). ": \n";
						//echo "exiftool -all:all= " . escapeshellarg("$incomingDir$prefix$filename");
						echo passthru("exiftool -all:all= " . escapeshellarg("$incomingDir$prefix$filename"));
						//echo "exiftool -delete_original! " . escapeshellarg("$incomingDir$prefix$filename");
						echo passthru("exiftool -delete_original! " . escapeshellarg("$incomingDir$prefix$filename"));
				   }
			   }
		   } else {
					echo "<p style=\"color: red;\">Warnung: Datei $longFilename existiert nicht.</p>";
		   }
            echo "</pre>";
            echo "</div>";
        }   
   } 
?>
        </div>
    </body>
</html>
   
   
   
