// 30.01.2014
// Version 1.3

jQuery(document).ready(function () {
	// Dokument-Id der Titelaufnahme ermitteln
	var dId = getDocumentId();

	// Nur im Admin-Bereich ausführen
	if(document.URL.match(/.*\/admin\/filemanager\/index\/id\/\d+\/?/g)) {
		// Jede Datei einzeln verarbeiten
		jQuery.each(jQuery('div.FileLink-data', '#fieldset-Files'), function () {
			var jqObj = jQuery(this);
			var fname = jqObj.find("div.field a").text();

			// Nur PDF-Dateien verarbeiten
			if(fname.match(/\.pdf$/g)) {
				jQuery.ajax({
					type: "GET",
					url: "/pdfmetadaten/info.php",
					async: true,				
					data: "documentId=" + dId + "&filename=" + fname,
					dataType: "json",
					timeout: 5000,			
					success: function (metaJson, text) {
								metadatenVerarbeitung(metaJson, text, jqObj);
							 },
					error: 	 function (metaJson, text) {
								metadatenVerarbeitung(metaJson, text, jqObj);
							 }
				});	
			}
		});
	}
});

function getDocumentId() {
	return document.URL.replace(/.*\/admin\/filemanager\/index\/id\/(\d+)(\/.*)?/g, "$1");
}

function metadatenVerarbeitung(metaJson, text, jqObj) {
	// Anzeige der Metadaten direkt oben bei der Datei
	var pdfMetaData = '<div class="label" style="margin-top: 10px;">PDF Metadaten</div>';
	pdfMetaData = pdfMetaData + '<div class="field" style="margin-top: 10px;">';
	pdfMetaData = pdfMetaData + "<b>Titel:</b> " + returnText(metaJson, 'Title') + "<br />";
	pdfMetaData = pdfMetaData + "<b>Autor:</b> " + returnText(metaJson, 'Author') + "<br />";
	pdfMetaData = pdfMetaData + "<b>Thema</b>: " + returnText(metaJson, 'Subject') + "<br />";
	pdfMetaData = pdfMetaData + "<b>Beschreibung</b>: " + returnText(metaJson, 'Description') + "<br />";
	pdfMetaData = pdfMetaData + "<b>Schlagworte:</b> " + returnText(metaJson, 'Keywords') + "<br />";
	pdfMetaData = pdfMetaData + "<br />";
	pdfMetaData = pdfMetaData + "<b>PDF-Version:</b> " + returnText(metaJson, 'PDF Version') + "<br />";
	if (isPdfA(metaJson) != 'Nein') {
		pdfMetaData = pdfMetaData + "<span style=\"color: orange;\"><b>PDF/A:</b> " + isPdfA(metaJson) + "</span><br />";
	} else {
		pdfMetaData = pdfMetaData + "<b>PDF/A:</b> " + isPdfA(metaJson) + "<br />";
	}
	if (returnText(metaJson, 'Encryption') == '') {
		pdfMetaData = pdfMetaData + "<b>Kennwortschutz:</b> " + returnText(metaJson, 'Encryption') + "<br />";
	} else {
		pdfMetaData = pdfMetaData + "<span style=\"color: red;\"><b>Kennwortschutz:</b> " + returnText(metaJson, 'Encryption') + "</span><br />";
	}
	pdfMetaData = pdfMetaData + "<b>Erstellt mit:</b> " + returnText(metaJson, 'Creator Tool') + "<br />";
	pdfMetaData = pdfMetaData + "<b>Datum der Erstellung:</b> " + returnText(metaJson, 'Create Date') + "<br />";
	pdfMetaData = pdfMetaData + "<br />";
	if(isPdfA(metaJson) == "Nein") {
		pdfMetaData = pdfMetaData + "<div><a href=\"/pdfmetadaten/entfernen.php?documentId=" + getDocumentId() + "&filename=" + jqObj.find("div.field a").text() + "\" target=\"_blank\" style=\"background: none; font-weight: normal;\">Kopie der Datei ohne Metadaten in incoming-Verzeichnis ablegen</a></div>";
	} else {
		pdfMetaData = pdfMetaData + "<div><span style=\"color: orange;\">Die Datei ist ein PDF/A und kann deshalb nicht bearbeitet werden</span></div>";
    }
	pdfMetaData = pdfMetaData + "<br /></div>";
	jqObj.append(pdfMetaData);
}

function returnText(metaJson, key) {
	var wert;
	wert = metaJson[key];
	
	if (! wert) {
		wert = "";
	}
	
	return wert;
}

function isPdfA(metaJson) {
	if (returnText(metaJson, 'Conformance') != '') {
		return "Ja (" + returnText(metaJson, 'Version ID') + returnText(metaJson, 'Conformance') + ")";
	} else {
		return "Nein";
	}
}
